// also see: 
// http://www.jjam.de/Java/Applets/Fraktale/Hilbert_Kurve.html

var len_original = 256;     
var rota = 90;
var depth = 1;
var clearflag = 1;
var dir, ax, ay, bx, by;


function msg_int(i) {
	if(i<=9 && i>0)
		setgen(i);
}

function setgen(i) {
	depth = i+1;
	
	len = len_original/Math.pow(2, depth-1);
	ax = ay = len / 2;
	dir = rota;       
	if(clearflag)
		outlet(0, "clear");
	hilbi("X", depth);
}


function size(a) {
	len_original = a;
	setgen(0);
}

function angle(a) {
	rota = a;
}

function autoclear(a) {
	if(a!=0) clearflag = 1;
	else clearflag = 0;
}



function hilbi(instruction, d) {
	var i, c;
	
	if(d <= 0) return;
        
	d--;
    //post(instruction, "\n");
    
	for(i=0; i<instruction.length; i++) {
		c = instruction[i];
		
		if(c=='X')
			hilbi("-YF+XFX+FY-", d);
		
		else if(c=='Y')
			hilbi("+XF-YFY-FX+", d);
			
		else if(c=='F') {
			var rad = 2*Math.PI/360 * dir;
			var p = len * Math.cos(rad);
			var q = len * Math.sin(rad);
			
			bx = ax+p;
			by = ay+q;
			
			outlet(0, "linesegment", ax, ay, bx, by);
			
			ax = bx; 
			ay = by;
		}
		
		else if(c=='+')
			dir += rota;
		
		else if(c=='-')
			dir -= rota;
	
	}
}

